# How to contribute to MISS_HIT

### Did you find a bug?

* **Ensure the bug was not already reported** by searching existing
  [Issues](https://github.com/florianschanda/miss_hit/issues).

* If you're unable to find an open issue addressing the problem,
  [open a new one](https://github.com/rails/rails/issues/new). 
  Be sure to include a **title and clear description**, as much
  relevant information as possible, and a **code sample**
  demonstrating the issue. Without such a reproducer it is
  unlikely that the problem can be fixed.

### Do you want a new feature?

* First open a new issue.

* Ideally, write code yourself and submit a PR. If you intend to do
  this, please state so clearly in your issue; that way I will
  only offer advice.

* I will deal with issues as I see fit. ;) But please see the
  last point below.

### Did you write a patch that fixes a bug?

* Open a new GitHub pull request with the patch. Make sure it
  references an existing open issue.
  
* Make sure all pre-commit checks pass, and the testsuite results
  are up-to-date and the documentation is done. Do all of this
  by running `make`
  
* Keep to the existing style please.

### Do you have questions about the source code?

* Send me an email. I may not have time to deal with it, especially
  if it's a really complex topic (e.g. why does the lexer handle ' the
  way it does?) or fundamentical (e.g. what is a lexer?). But please
  see the last point below.

### Contributing financially

* This project is a labour of love and hate. It's quite likely I will do
  whatever you need, because people using this for something real is cool!
  But please be aware that I have a limited amount of spare time...
  
* If you *must* have your feature implemented by time X, or your
  question answered by time X we can discuss a reasonable rate. :)
